/*
	ncbricks - ncurses based brick breaker
	Copyright (C) 2017-2018  Aron Barath

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
	02110-1301  USA
*/

#ifndef PTRARR_H
#define PTRARR_H

#include <stddef.h>

struct ptrarr
{
	void** pointers;
	size_t size;
	size_t capacity;
};

/* these function will call abort() on memory shortage */

void ptrarr_init(struct ptrarr* const arr);
void ptrarr_add(struct ptrarr* const arr, void* const ptr);
void ptrarr_remove(struct ptrarr* const arr, size_t index);

#endif // PTRARR_H
